<?php
namespace App\controleur;


use App\router\AltoRouter;


class FrontControleur
{
    public function __construct()
    {
        $router = new AltoRouter();

        $router->setBasePath('/php');

        $router->map('GET','/','UtilisateurControleur');

        $router->map('GET|POST','/user/[i:id]/[a:action]?','MembreControleur');

        $router->map('GET|POST','/admin/[i:id]/[a:action]?','AdminControleur');

        $id = 0;


        $match = $router->match();
        $action = array();

        $id=array();

        if(!$match)
        {
            global $twig;
            $dVueErreur[]  = "Error 404 Page not found";
            echo $twig->render("erreur.html", ['dVueErreur' => $dVueErreur]);
        }

        if($match)
        {
            $controller = $match['target'] ?? NULL;
            $action = $match['params']['actions'] ?? NULL;
            $id = $match['params']['id'] ?? NULL;

        }

        try{
            $controller = new $controller;
        }
        catch (Error $error)
        {
            $dVueErreur = ['Erreur : Action inconnue'];
            $twig->render('erreur.html', ['dVueErreur' => $dVueErreur]);
        }

    }




}

/*class FrontControleur
{
    public function __construct()
    {
        global $twig;
        session_start();
        $dVueErreur = [];
        $actions = array(
            "Admin" => [
                "supprimerCompte", "consulterSignalement","supprimerOffre"
            ],
            "Moderateur" => [
                //TODO
            ],
            "Membre" => [
                "deconnexion","proposerOffre","consulterProfil","modifierProfil","signaler",
            ],
            "Utilisateur" => [

                "connexion", "inscription", "accueil", "consulterProfilLimite", "publierOffre", "listerEvenement", "creerEvenement", "supprimerEvenement", "avoirDetailEvenement", "rechercherEvenement"
            ]
        );

        $action = \App\config\Validation::nettoyerString($_GET["action"] ?? "");
        if(in_array($action,$actions['Admin'])) {
            if (!isset($_SESSION["role"]) || $_SESSION["role"]!="admin") {
                $dVueErreur[] = 'Veuillez vous connecter';
                echo $twig->render('erreur.html', ['dVueErreur' => $dVueErreur]);
            } else{
                new AdminControleur();
            }
        }
        else if(in_array($action,$actions['Moderateur'])) {
            if (!isset($_SESSION["role"]) || ($_SESSION["role"]!="moderateur" && $_SESSION["role"]!="admin")) {
                $dVueErreur[] = 'Veuillez vous connecter';
                echo $twig->render('erreur.html', ['dVueErreur' => $dVueErreur]);
            } else{
                new ModerateurControleur();
            }
        }
        else if(in_array($action,$actions['Membre'])) {
            if (!isset($_SESSION["utilisateur"])) {
                $dVueErreur[] = 'Veuillez vous connecter';
                echo $twig->render('erreur.html', ['dVueErreur' => $dVueErreur]);
            } else{
                new MembreControleur();
            }
        }else{
            new UtilisateurControleur();
        }
    }
}*/
